From e6ee31675780460620d9f996024f766838bdba1b Mon Sep 17 00:00:00 2001
From: Olof-Joachim Frahm <olof@macrolet.net>
Date: Thu, 20 Mar 2014 21:03:24 +0100
Subject: [PATCH 3/3] Include version in system/contrib jar pathname.

---
 abcl/src/org/armedbear/lisp/abcl-contrib.lisp |   26 +++++++++++++++----------
 1 file changed, 16 insertions(+), 10 deletions(-)

diff --git a/abcl/src/org/armedbear/lisp/abcl-contrib.lisp b/abcl/src/org/armedbear/lisp/abcl-contrib.lisp
index fb7e8e9..4fbc393 100644
--- a/abcl/src/org/armedbear/lisp/abcl-contrib.lisp
+++ b/abcl/src/org/armedbear/lisp/abcl-contrib.lisp
@@ -27,7 +27,7 @@ (defun named-jar-p (name p)
                       "java.util.regex.Pattern"
                       (concatenate 'string name "(-[0-9]\\.[0-9]\\.[0-9]\\.[0-9]([+~-]+)?)?")
                       (pathname-name p)))
-       (make-pathname :defaults p :name name)))
+       p))
 
 (defun find-system ()
   "Find the location of the system.
@@ -46,12 +46,21 @@ (defun find-system ()
    (ignore-errors
      #p"http://abcl.org/releases/current/abcl.jar")))
 
-(defun find-system-jar ()
-  "Return the pathname of the system jar, one of `abcl.jar` or `abcl-m.n.p.jar` or `abcl-m.n.p[.~-]something.jar`."
+(defun find-jar (predicate)
   (dolist (loader (java:dump-classpath))
-    (let ((abcl-jar (some #'system-jar-p loader)))
-      (when abcl-jar
-        (return abcl-jar)))))
+    (let ((jar (some predicate loader)))
+      (when jar
+        (return jar)))))
+
+(defun find-system-jar ()
+  "Return the pathname of the system jar, one of `abcl.jar` or
+`abcl-m.n.p.jar` or `abcl-m.n.p[.~-]something.jar`."
+  (find-jar #'system-jar-p))
+
+(defun find-contrib-jar ()
+  "Return the pathname of the contrib jar, one of `abcl-contrib.jar` or
+`abcl-contrib-m.n.p.jar` or `abcl-contrib-m.n.p[.~-]something.jar`."
+  (find-jar #'contrib-jar-p))
 
 (defvar *abcl-contrib* nil
   "Pathname of the ABCL contrib.
@@ -87,10 +96,7 @@ (defun find-and-add-contrib (&key (verbose nil))
 (defun find-contrib ()
   "Introspect runtime classpaths to find a loadable ABCL-CONTRIB."
   (or (ignore-errors
-        (when (find-system-jar)
-          (probe-file
-           (make-pathname :defaults (find-system-jar)
-                          :name "abcl-contrib"))))
+        (find-contrib-jar))
       (some
        (lambda (u)
          (probe-file (make-pathname
-- 
1.7.10.4

